000010 IDENTIFICATION DIVISION.                                         00000010
000060 PROGRAM-ID.    TESTPGM1.                                         00000030
000140 ENVIRONMENT    DIVISION.                                         00000110
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT INPUT1  ASSIGN DDI1.
           SELECT INPUT2  ASSIGN DDI2.
           SELECT OPTIONAL  OUTPUT1 ASSIGN  TO DDO1.
       
000150 DATA           DIVISION.                                         00000120
       FILE SECTION.
       FD  INPUT1  BLOCK 10 RECORDS              
                   RECORD 200  CHARACTERS.    
       01  IN01.
           03  FILLER            PIC  X(100).
           03  FILLER            PIC  X(100).  
       01  IN011                 PIC  X(200). 
       FD  INPUT2  BLOCK 10 RECORDS.              
       01  IN02.
           03  FILLER            PIC  X(300).
           03  FILLER            PIC  X(100).  
       FD  OUTPUT1 BLOCK CONTAINS 10  TO  20  RECORDS    
                   RECORD CONTAINS 100 TO 1000 CHARACTERS.               
       01  OT01.
           03   FILLER          PIC  X(100).     
000160 WORKING-STORAGE SECTION.                                         00000130
       01  XYZ                          PIC  99999.
000240 01  WK-DATE.                                                     00000210
000250     03  WK-DT-MM                 PIC  9(2).                      00000220
000260     03  FILLER                   PIC  X.                         00000230
000270     03  WK-DT-DD                 PIC  9(2).                      00000240
000280     03  FILLER                   PIC  X.                         00000250
000290     03  WK-DT-YY                 PIC  9(2).                      00000260
       01  XDATE-EDIT-YMD.              
           03  XDATE-WAREKI.
               05  XDATE-WAREKI-YY.
                   07  XDATE-WAREKI-YY9     PIC  9(2). 
       01  DA-DATE.
           03  DA-YYYY-DATE                   PIC  9(8).        
       01  O-01.
           COPY TESTCPYA.
       01  O-02.
           COPY TESTCPYA.
       01  P-01-01-200-TESTPGM1.
           COPY TESTCPYB  REPLACING  ==TESTCPYB== BY ====.
       01  Q-01-01-200-TESTPGM1.
           COPY TESTCPYC  REPLACING  =='A'== BY ==AA-==
                                     =='B'== BY ==BBB-==
                                     =='C'== BY ==CCCC-==
                   ==03  TESTCPYC-03-4       PIC  9.==
                              BY ====.
       01  DISPLAY3  PIC  X(20)  VALUE   'DISPLAY VALUE1'.      
       01  DISPLAY4  PIC  X(20)  VALUE   'DISPLAY VALUE4'.      
       01  SUBPGM2                     PIC  X(08)   VALUE  'SUBC1'.        
       01  SUBPGM3                     PIC  X(8)    VALUE  'SUBC2'.         
       01  WK-LIKAGE.
           03  LINKAGE1                  PIC  X(20)  VALUE 'LIKAGE1'.   
           03  LINKAGE2                  PIC  X(20)  VALUE 'LIKAGE2'. 
           03  LINKAGE3                  PIC  X(20)  VALUE 'LIKAGE3'. 
       01  WK-XCTL-PGM                 PIC  X(08)    VALUE 'ONPGMC1'.  
       01  COMM-LENGTH                 PIC  9(08)  COMP.
       01  DFHCOMMAREA                 PIC  X(100).
       01  COM001C1                    PIC  X(200).
       01  TEST01M1I                   PIC  X(100).
       01  TEST01M1O                   PIC  X(100).
       01  WK-INPUT1                   PIC  X(100).
       01  WK-OUTPUT1                  PIC  X(100).
       01  WK-UPDATE                     PIC  X(100).
       01  WK-IF.
           03  WK-IF1                 PIC  X(10)  VALUE '1'.
           03  WK-IF2                 PIC  X(10)  VALUE '2'.
       01    WK-EVALUATE1          PIC  X(5).
000470 LINKAGE SECTION.                                                 00000400
000480 01  A-01-01-10-LK-TESTPGM1.                                      00000410
000490     03  A-03-01-05-LK-TESTPGM1   PIC  X(5).                      00000420
           03  A-03-02-05-LK-TESTPGM1   PIC  9(05).                                
000480 01  B-01-01-110-LK-TESTPGM1.                                     00000410
000490     03  B-03-01-05-LK-TESTPGM1   PIC  X(5).                      00000420
           03  B-03-02-105-LK-TESTPGM1   PIC  X(105).                   
000550 EJECT                                                            00000480
000560 PROCEDURE      DIVISION.                                         00000490
            MOVE  'O-01 testcpya-03-1'  TO  TESTCPYA-03-1 OF O-01.
            MOVE  'O-02 TESTCPYA-03-1'  TO  TESTCPYA-03-1 OF O-02.
            IF  TESTCPYA-03-4  OF O-01  NUMERIC
                DISPLAY '  TEST'.  
            IF  TESTCPYA-03-5  OF O-01  IS NUMERIC
                DISPLAY '  TEST'.  
            IF  TESTCPYA-03-6  OF O-01  NOT NUMERIC
                DISPLAY '  TEST'.  

            IF    'IF O-01 TESTCPYA-03-1'  =   TESTCPYA-03-1 OF O-01
                      DISPLAY 'XXXX'.
            IF    'IF O-02 TESTCPYA-03-1'  =   TESTCPYA-03-1 OF O-02
                      DISPLAY 'XXXX'.
            PERFORM L-PERFORM1  THRU  L-PERFORM1-EXT.
            ACCEPT  WK-DATE     FROM  DATE.                                     
            ACCEPT  WK-DATE     FROM  DATE.                                     
            ACCEPT  WK-DATE     FROM  DAY.                                     
            ACCEPT  WK-DATE     FROM  DAY-OF-WEEK.                                     
            CALL   'SUBC2'     USING BY REFERENCE  LINKAGE1
                   LINKAGE2 LINKAGE3      
                   ON OVERFLOW  GO TO  LABEL2  END-CALL.                    
            CALL   SUBPGM2. 
            MOVE   'SUBC3'     TO  SUBPGM2.  
            MOVE   'SUBC4'     TO  SUBPGM2.  
            MOVE   'SUBC5'     TO  SUBPGM2. 
            MOVE   SUBPGM3        TO  SUBPGM2. 
            MOVE   'SUBC6'     TO  SUBPGM3. 
            MOVE  'TESTPGMB -1 '   TO  TESTCPYA-03-3 OF O-01.
            MOVE  'TESTPGMB -2 '   TO  TESTCPYA-03-3 OF O-01.
            MOVE  'TESTPGMB -3 '   TO  TESTCPYA-03-3 OF O-01.
       LABEL1.
       LABEL2.
       LABEL3.
           IF  IN01  =  'kkkk'  
                 MOVE  'IN01 DATA'  TO  IN01.
           MOVE  WK-DATE   TO  IN01.
           MOVE  TESTCPYA-03-1 OF O-01  TO  IN01.
           COMPUTE   IN01  =  WK-UPDATE  *  20  + 1.
           MOVE  'IN011 DATA'  TO  IN011.
           ADD  100  TO  WK-OUTPUT1.
           SUBTRACT   200  *  10  FROM  WK-OUTPUT1.
           MOVE  IN01   TO  LINKAGE2.
           IF  A-03-01-05-LK-TESTPGM1  >=   SUBPGM2 
               MOVE  IN01   TO  A-03-01-05-LK-TESTPGM1.
           COMPUTE  A-03-01-05-LK-TESTPGM1 =  IN01  + 100 - 50 * 2.
123456 L-PERFORM1.
                  PERFORM  L-PERFORM11  THRU  L-PERFORM11-EXT.
                  PERFORM  L-PERFORM12  THRU  L-PERFORM12-EXT.
002010         EXEC      CICS      HANDLE    CONDITION                  00001970
002020                             ERROR    (E9000-ERROR)               00001980
002030         END-EXEC.                                                00001990
               MOVE     'ONPGMC1'  TO  WK-XCTL-PGM.                             
               MOVE     'ONPGMC2'  TO  WK-XCTL-PGM.                             
008210         EXEC      CICS      XCTL                                 00008160
008220                             PROGRAM  ('ONPGMC3')                00008170
008230                             COMMAREA (DFHCOMMAREA)               00008180
008240                             LENGTH   (200)                       00008190
008250         END-EXEC.                                                00008200
008380         EXEC      CICS      XCTL                                 00008330
008390                             PROGRAM  (WK-XCTL-PGM)               00008340
008400                             COMMAREA (DFHCOMMAREA)               00008350
008410                             LENGTH   (COMM-LENGTH)               00008360
008420         END-EXEC.                                                00008370
009070         EXEC CICS LINK PROGRAM  ('LNPGMC1')                              
009080                        COMMAREA (COM001C1)                                
009090                        LENGTH   (100)                                    
009100         END-EXEC.                                                        
009260         EXEC      CICS      RETURN                               00009140
009270                             TRANSID  ('AAA1')                    00009150
009280                             COMMAREA (DFHCOMMAREA)               00009160
009290                             LENGTH   (COMM-LENGTH)               00009170
009300         END-EXEC.                                                00009180
123456 L-PERFORM1-EXT.       
123456 E9000-ERROR.
           DISPLAY  'DISPLAY 1'.
           DISPLAY  'DISPLAY 2 '  XDATE-WAREKI-YY9.
           DISPLAY  'DISPLAY 3 '  DISPLAY3. 
           DISPLAY  'DISPLAY 1 '  DISPLAY3. 
           MOVE  'DISPLAY MOVE VALUE1'  TO  DISPLAY3.
           MOVE  'DISPLAY MOVE VALUE2'  TO  DISPLAY3.
           MOVE  'DISPLAY MOVE VALUE3'  TO  DISPLAY3.
           MOVE  DISPLAY4               TO  DISPLAY3.
           IF  WK-IF1  =  WK-IF2
              MOVE  'WK-IF1'  TO  WK-IF1.
            EVALUATE  WK-EVALUATE1
               WHEN   18  THRU   29
               WHEN   40  THRU   60
                      MOVE  'WK-1'  TO  WK-EVALUATE1
               WHEN  61    THRU  100
                      MOVE  'WK-2'  TO  WK-EVALUATE1
               WHEN   OTHER
                      MOVE  'WK-3'  TO  WK-EVALUATE1
           END-EVALUATE.
123456 L-PERFORM11.       
000298        EXEC CICS RECEIVE  MAP ('TEST01M1')  
00300                  MAPSET  ('TEST01M1')   INTO  (TEST01M1I)   
000302        END-EXEC.                                                 00002790
001200        EXEC CICS SEND   MAP  ('TEST01M1')  
001202              MAPSET   ('TEST01M1')  FROM (TEST01M1O)     
001204                  ERASE  FREEKB   CURSOR  END-EXEC.   
123456 L-PERFORM11-EXT.       
123456 L-PERFORM12.       
         OPEN    INPUT  INPUT1  WITH NO REWIND OUTPUT OUTPUT1.
           CLOSE   INPUT1  OUTPUT1.
           OPEN    EXTEND  INPUT1.
           CLOSE   INPUT1  .
           OPEN    OUTPUT  INPUT1.
           OPEN   I-O     INPUT1  .
           READ   INPUT1  INTO  WK-INPUT1 NEXT RECORD 
                  NOT AT END  GO TO L1000  END-READ.
           WRITE  OT01   FROM  WK-OUTPUT1  BEFORE ADVANCING  2 LINE
                  NOT AT  END-OF-PAGE  GO  TO  L1000   END-WRITE.
           WRITE  OT01   FROM  WK-OUTPUT1  AFTER ADVANCING  2 LINES
                  NOT AT  EOP  GO  TO  L1000   END-WRITE.
           REWRITE  OT01   FROM  WK-UPDATE   END-REWRITE.
       L1000.
123456 L-PERFORM12-EXT.       
000790     EXEC    CICS LINK PROGRAM  ('SUB001')                               
000800          COMMAREA (DA-DATE)  LENGTH   (100)  END-EXEC.                                                            
           COMPUTE  XYZ  = 200 + 120 * -200 / (-20 + 010). 
001070 END-RTN.                                                         00000930
001080     EXEC    CICS    RETURN                          END-EXEC.    00000940
001100     GOBACK.                                                      00000960